library testlib;

uses
  TestIntf;

type
  TTest = class (TInterfacedObject, ITest)
  private
    procedure TestMe;
  public
    constructor Create;
    destructor Destroy; override;
    procedure AfterConstruction; override;
    procedure BeforeDestruction; override;
  end;

{ TTest }

{ Private declarations }

procedure TTest.TestMe;
begin
  Writeln('Hello, world!');
end;

{ Public declarations }

constructor TTest.Create;
begin
  Writeln('TTest.Create; RefCount=', RefCount);
  inherited Create;
  Writeln('TTest.Create; RefCount=', RefCount);
end;

destructor TTest.Destroy;
begin
  Writeln('TTest.Destroy; RefCount=', RefCount);
  inherited Destroy;
  Writeln('TTest.Destroy; RefCount=', RefCount);
end;

procedure TTest.AfterConstruction;
begin
  Writeln('TTest.AfterConstruction; RefCount=', RefCount);
  inherited AfterConstruction;
  Writeln('TTest.AfterConstruction; RefCount=', RefCount);
end;

procedure TTest.BeforeDestruction;
begin
  Writeln('TTest.BeforeDestruction; RefCount=', RefCount);
  inherited BeforeDestruction;
  Writeln('TTest.BeforeDestruction; RefCount=', RefCount);
end;

var
  C: TTest = nil;

function GetITest: ITest;
begin
  C := TTest.Create;
  Result := C as ITest;
end;

exports
  GetITest;

begin
end.
